function events(Twin,TAB,data,Ener,Births,miam,Nvisites,lastTar,miamTar)

  ## this function is used at the end of each 5,000-time-steps time window to update TAB
    # 1st column: time window id
    # 2nd column: nb of individuals alive at the beginning of the time window
    # 3rd column: individual id
    # 4th column: mean resource intake per 100 time steps over the time window (if the individual did not die)
    # 5th column: number of patches visited during the time window  (if the individual did not die)
    # 6th column: mean amount of food found per patch visit during the time window (if the individual did not die)
    # 7th column: std of the amount of found found per patch visit during the time window (if the individual did not die)
    # 8th column: 1 if the individual did not die during the time window, 0 otherwise
    # 9th column: number of offspring of the individual born within the time window
    # 10th column: local competition experienced by the individual on the patches it used (if the individual did not die)
    # 11th column: number of DIFFERENT patches visited during the time window (if the individual did not die)

  # Twin: time window index
  # for other variables, see "initial.jl" for details

  nvdeb = size(find(Ener[((Twin-1)*5000)+1,:].>0),1)  # nb of individuals alive at the beginning of the time window

  if sum(Ener[((Twin-1)*5000)+1,:])>0                 # if at least one individual is alive at the beginning of the time window

    for i in find(Ener[((Twin-1)*5000)+1,:].>0)       # for each individual alive at the beginning of the time window
      TAB = cat(1,TAB,zeros(1,11))
      lineIND = size(TAB,1)

      TAB[lineIND,1] = Twin
      TAB[lineIND,2] = nvdeb
      TAB[lineIND,3] = i

      TAB[lineIND,9] = size(find((Births[:,3].==i) & (Births[:,2].>(Twin-1)*5000)),1)

      # if the individual did not die during the time window
      if Ener[Twin*5000,i] >0
        TAB[lineIND,4] = miam[i]/50
        TAB[lineIND,5] = Nvisites[i]
        TAB[lineIND,8] = 1
        TAB[lineIND,6] = miam[i]/Nvisites[i]
        miamTarFoc = miamTar[:,i]
        miamTarFoc2 = miamTarFoc[find(miamTarFoc.>0)]
        TAB[lineIND,7] = sqrt(var(miamTarFoc2))

        ## local competition measure
        lastTarsubFoc = lastTar[:,i]
        lastTarsub2Foc = lastTarsubFoc[find(lastTarsubFoc.>0)]

        NVi = size(lastTarsub2Foc,1)   # nb of patches visited by the individual
        NVtot = 0                      # nb of times any patch used by the focal individual has been visited by another

        k=1
        for p in unique(lastTarsub2Foc)
           nVother = 0
           for j in 1:size(lastTar,2)  # for all individuals (other than i)
             if j != i
               lastTarsub = lastTar[:,j]
               nVother = nVother +  size(find(lastTarsub.==p),1)
             end
           end
           NVtot += nVother
           k += 1
        end
        TAB[lineIND,10] = NVtot/(NVi*size(unique(lastTarsub2Foc),1))
	TAB[lineIND,11] = size(unique(lastTarsub2Foc),1)

      else
        TAB[lineIND,4] = NaN
        TAB[lineIND,5] = NaN
        TAB[lineIND,6] = NaN
        TAB[lineIND,7] = NaN
        TAB[lineIND,10] = NaN
	TAB[lineIND,11] = NaN
      end
    end
  end

  return TAB
end
