function updateIbin(ito,TR,TW)

  ## this function updates the cognitive map (ito matrix) of an individual

  ## ito characteristics : one column per patch
    # 1st row = 1 if patch is known, 0 otherwise
    # 2nd row = time since the last visit if patch is known
    # 3rd row = 1 if sufficient time (TW) has NOT yet elapsed
    # 4th row = remembered apparent quality of the patch IF IT IS KNOWN
    # 5th row = expected value of the patch (not discounting for distance to be travelled)

  for i in 1:size(ito,2)      # do it for all patches

    if ito[1,i] > 0           # if the patch is known, increment the time since last visit
      ito[2,i] = ito[2,i]+1
    end

    if ito[2,i] > TR          # if TR is exceeded, the patch is forgotten
      ito[1,i] = 0
      ito[4,i] = 0
    end

    if ito[2,i] > TW          # if TW is exceeded, the unwillingness to go back to the patch drops to zero
      ito[3,i] = 0
    end

  end
  return ito
end
